<template>
  <form-container v-slot="{ send, submission }" endpoint="contact">
    <a-form
      v-slot="{ updateField, errors }"
      v-bind="{ send, submission, fields: $refs }"
    >
      <a-name-field ref="nombre" label="Nombre" @blur="updateField">
        <p v-if="errors.has('nombre')" class="mt-2 text-sm text-red-error">
          {{ errors.first('nombre') }}
        </p>
      </a-name-field>

      <a-email-field
        ref="correo"
        class="mt-6"
        label="Correo electrónico"
        @blur="updateField"
      >
        <p v-if="errors.has('correo')" class="mt-2 text-sm text-red-error">
          {{ errors.first('correo') }}
        </p>
      </a-email-field>

      <a-phone-field
        ref="teléfono"
        class="mt-6"
        label="Teléfono"
        @blur="updateField"
      >
        <p v-if="errors.has('teléfono')" class="mt-2 text-sm text-red-error">
          {{ errors.first('teléfono') }}
        </p>
      </a-phone-field>

      <a-subject-field
        ref="asunto"
        class="mt-6"
        label="Asunto"
        @blur="updateField"
      >
        <p v-if="errors.has('asunto')" class="mt-2 text-sm text-red-error">
          {{ errors.first('asunto') }}
        </p>
      </a-subject-field>

      <a-message-field
        ref="mensaje"
        class="mt-6"
        label="Mensaje"
        @blur="updateField"
      >
        <p v-if="errors.has('mensaje')" class="mt-2 text-sm text-red-error">
          {{ errors.first('mensaje') }}
        </p>
      </a-message-field>

      <a-terms-field
        ref="privacidad"
        class="mt-6"
        label="He leído y acepto la política de privacidad"
        @blur="updateField"
      >
        <p v-if="errors.has('privacidad')" class="mt-2 text-sm text-red-error">
          {{ errors.first('privacidad') }}
        </p>
      </a-terms-field>

      <a-submit-button
        class="mt-12"
        :status="submission"
        :label="{ idle: 'Enviar', success: 'Enviado', error: 'Error' }"
        :color="{
          idle: 'bg-gray-500 hover:bg-gray-600',
          pending: 'bg-gray-500',
        }"
      />
    </a-form>
  </form-container>
</template>

<script>
import FormContainer from '~/containers/FormContainer';
import {
  AForm,
  ASubmitButton,
  ANameField,
  AEmailField,
  APhoneField,
  ASubjectField,
  AMessageField,
  ATermsField,
} from '~/components/forms';

export default {
  name: 'ContactForm',
  components: {
    FormContainer,
    AForm,
    ASubmitButton,
    ANameField,
    AEmailField,
    APhoneField,
    ASubjectField,
    AMessageField,
    ATermsField,
  },
};
</script>
